package com.me.asteroids;

import com.me.asteroids.events.BulletAsteroidCollisionEvent;
import com.me.asteroids.events.CollisionEvent;
import com.me.asteroids.events.PlayerASteroidCollisionEvent;
import com.me.common.ecs.Entity;

import static com.me.asteroids.Components.ASTEROID;
import static com.me.asteroids.Components.BULLET;
import static com.me.asteroids.Components.PLAYER;

public class EventFactory {

    public static CollisionEvent getNewCollisionEvent(Entity a, Entity b) {
        boolean isEntityAPlayer = PLAYER.has(a);
        boolean isEntityBPlayer = PLAYER.has(b);
        boolean isEntityABullet = !isEntityAPlayer && BULLET.has(a);
        boolean isEntityBBullet = !isEntityBPlayer && BULLET.has(b);
        boolean isEntityAAsteroid = !isEntityAPlayer && !isEntityABullet && ASTEROID.has(a);
        boolean isEntityBAsteroid = !isEntityBPlayer && !isEntityBBullet && ASTEROID.has(b);

        if (isEntityAAsteroid || isEntityBAsteroid) {
            if (isEntityAPlayer && isEntityBAsteroid) {
                return new PlayerASteroidCollisionEvent(a, b);
            } else if (isEntityBPlayer && isEntityAAsteroid) {
                return new PlayerASteroidCollisionEvent(b, a);
            } else if (isEntityABullet && isEntityBAsteroid) {
                return new BulletAsteroidCollisionEvent(a, b);
            } else if (isEntityBBullet && isEntityAAsteroid) {
                return new BulletAsteroidCollisionEvent(b, a);
            }
        }

        return new CollisionEvent(a, b);
    }

}
